#!/bin/sh

#Clean the directory first
cd /workspace
if [ -a fom/fips ]; then rm -rf fom/fips; fi
./config
make clean

#Begin FOM build
CURDIR=$PWD
echo ${CURDIR}
cd fom
FOMBALL=`ls *.gz`
echo ${FOMBALL}
NUMPARTS=`echo ${FOMBALL} | awk -F'.' '{print NF}'`
echo ${NUMPARTS}
FOMBASE=`echo ${FOMBALL} | awk -F'.' '{print $1}'`
FOMMAJOR=`echo ${FOMBALL} | awk -F'.' '{print $2}'`
if [ "$NUMPARTS" -eq 5 ] 
then
    FOMMINOR=`echo ${FOMBALL} | awk -F'.' '{print $3}'`
    FOMDIR="$FOMBASE.$FOMMAJOR.$FOMMINOR"
else
    FOMDIR="$FOMBASE.$FOMMAJOR"
fi
echo ${FOMDIR}

tar -xzvf ${FOMBALL}
cd ${FOMDIR}
pwd

./config fipscanisteronly --prefix=${CURDIR}/fom/fips
make
make install


cd ${CURDIR}
patch -p1 < abi-builds/centos6.8/abi-compat.patch
./Configure linux-x86_64 fips shared --with-fipsdir=${CURDIR}/fom/fips --openssldir=${CURDIR}/usr/local/cisco/ssl --prefix=${CURDIR}/usr/local/cisco/ssl zlib enable-rc4 enable-ssl2 enable-camellia enable-seed enable-tlsext enable-rfc3779 enable-cms enable-md2 no-mdc2 no-rc5 no-ec2m no-gost no-srp --with-krb5-flavor=MIT --with-krb5-dir=/usr -Wa,--noexecstack
make depend
cp abi-builds/centos6.8/version.map .
make
strip libcrypto.a
strip libcrypto.so
strip libssl.a
strip libssl.so
strip apps/openssl
strip engines/*.so
make install_sw
