/* crypto/rand/rand_err.c */
/* ====================================================================
 * Copyright (c) 1999-2015 The OpenSSL Project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit. (http://www.OpenSSL.org/)"
 *
 * 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    openssl-core@OpenSSL.org.
 *
 * 5. Products derived from this software may not be called "OpenSSL"
 *    nor may "OpenSSL" appear in their names without prior written
 *    permission of the OpenSSL Project.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit (http://www.OpenSSL.org/)"
 *
 * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenSSL PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

/*
 * NOTE: this file was auto generated by the mkerr.pl script: any changes
 * made to it will be overwritten when the script next updates this file,
 * only reason strings will be preserved.
 */

#include <stdio.h>
#include <openssl/err.h>
#include <openssl/rand.h>

/* BEGIN ERROR CODES */
#ifndef OPENSSL_NO_ERR

# define ERR_FUNC(func) ERR_PACK(ERR_LIB_RAND,func,0)
# define ERR_REASON(reason) ERR_PACK(ERR_LIB_RAND,0,reason)

static ERR_STRING_DATA RAND_str_functs[] = {
    {ERR_FUNC(RAND_F_DRBG_BYTES), "DRBG_BYTES"},
    {ERR_FUNC(RAND_F_DRBG_CHECK), "DRBG_CHECK"},
    {ERR_FUNC(RAND_F_DRBG_ERROR_CHECK), "DRBG_ERROR_CHECK"},
    {ERR_FUNC(RAND_F_DRBG_GENERATE), "DRBG_GENERATE"},
    {ERR_FUNC(RAND_F_DRBG_INIT), "DRBG_INIT"},
    {ERR_FUNC(RAND_F_DRBG_INSTANTIATE), "DRBG_INSTANTIATE"},
    {ERR_FUNC(RAND_F_DRBG_NEW), "DRBG_NEW"},
    {ERR_FUNC(RAND_F_DRBG_RESEED_LCL), "DRBG_RESEED_LCL"},
    {ERR_FUNC(RAND_F_DRBG_SINGLE_KAT), "DRBG_SINGLE_KAT"},
    {ERR_FUNC(RAND_F_GET_ENTROPY), "GET_ENTROPY"},
    {ERR_FUNC(RAND_F_RAND_GET_DRBG_METHOD), "RAND_GET_DRBG_METHOD"},
    {ERR_FUNC(RAND_F_RAND_GET_RAND_METHOD), "RAND_get_rand_method"},
    {ERR_FUNC(RAND_F_RAND_INIT_FIPS), "RAND_init_fips"},
    {ERR_FUNC(RAND_F_RAND_POLL), "RAND_poll"},
    {ERR_FUNC(RAND_F_RDRAND_STIR), "RDRAND_STIR"},
    {ERR_FUNC(RAND_F_SSLEAY_RAND_BYTES), "SSLEAY_RAND_BYTES"},
    {0, NULL}
};

static ERR_STRING_DATA RAND_str_reasons[] = {
    {ERR_REASON(RAND_R_ADDITIONAL_INPUT_ERROR_UNDETECTED),
     "additional input error undetected"},
    {ERR_REASON(RAND_R_DUAL_EC_DRBG_DISABLED), "dual ec drbg disabled"},
    {ERR_REASON(RAND_R_ENTROPY_ERROR_UNDETECTED), "entropy error undetected"},
    {ERR_REASON(RAND_R_ENTROPY_NOT_REQUESTED_FOR_RESEED),
     "entropy not requested for reseed"},
    {ERR_REASON(RAND_R_ENTROPY_SOURCE_STUCK), "entropy source stuck"},
    {ERR_REASON(RAND_R_ERROR_INITIALISING_DRBG), "error initialising drbg"},
    {ERR_REASON(RAND_R_ERROR_INSTANTIATING_DRBG), "error instantiating drbg"},
    {ERR_REASON(RAND_R_ERROR_RETRIEVING_ADDITIONAL_INPUT),
     "error retrieving additional input"},
    {ERR_REASON(RAND_R_FUNCTION_ERROR), "function error"},
    {ERR_REASON(RAND_R_GENERATE_ERROR_UNDETECTED),
     "generate error undetected"},
    {ERR_REASON(RAND_R_NONCE_ERROR_UNDETECTED), "nonce error undetected"},
    {ERR_REASON(RAND_R_NOPR_TEST1_FAILURE), "nopr test1 failure"},
    {ERR_REASON(RAND_R_NOPR_TEST2_FAILURE), "nopr test2 failure"},
    {ERR_REASON(RAND_R_NO_FIPS_RANDOM_METHOD_SET),
     "no fips random method set"},
    {ERR_REASON(RAND_R_PERSONALISATION_ERROR_UNDETECTED),
     "personalisation error undetected"},
    {ERR_REASON(RAND_R_PRNG_NOT_SEEDED), "PRNG not seeded"},
    {ERR_REASON(RAND_R_PR_TEST1_FAILURE), "pr test1 failure"},
    {ERR_REASON(RAND_R_PR_TEST2_FAILURE), "pr test2 failure"},
    {ERR_REASON(RAND_R_RDRAND_FAILED), "rdrand failed"},
    {ERR_REASON(RAND_R_REQUEST_LENGTH_ERROR_UNDETECTED),
     "request length error undetected"},
    {ERR_REASON(RAND_R_RESEED_COUNTER_ERROR), "reseed counter error"},
    {ERR_REASON(RAND_R_SELFTEST_FAILED), "selftest failed"},
    {ERR_REASON(RAND_R_SELFTEST_FAILURE), "selftest failure"},
    {ERR_REASON(RAND_R_UNINSTANTIATE_ERROR), "uninstantiate error"},
    {ERR_REASON(RAND_R_UNINSTANTIATE_ZEROISE_ERROR),
     "uninstantiate zeroise error"},
    {ERR_REASON(RAND_R_UNSUPPORTED_DRBG_TYPE), "unsupported drbg type"},
    {0, NULL}
};

#endif

void ERR_load_RAND_strings(void)
{
#ifndef OPENSSL_NO_ERR

    if (ERR_func_error_string(RAND_str_functs[0].error) == NULL) {
        ERR_load_strings(0, RAND_str_functs);
        ERR_load_strings(0, RAND_str_reasons);
    }
#endif
}
