/* e_ctamc_err.c */
/* ====================================================================
 * Copyright (c) 1999-2011 The OpenSSL Project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit. (http://www.OpenSSL.org/)"
 *
 * 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    openssl-core@OpenSSL.org.
 *
 * 5. Products derived from this software may not be called "OpenSSL"
 *    nor may "OpenSSL" appear in their names without prior written
 *    permission of the OpenSSL Project.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit (http://www.OpenSSL.org/)"
 *
 * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenSSL PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

/*
 * NOTE: this file was auto generated by the mkerr.pl script: any changes
 * made to it will be overwritten when the script next updates this file,
 * only reason strings will be preserved.
 */

#include <stdio.h>
#include <openssl/err.h>
#include "e_ctamc_err.h"

/* BEGIN ERROR CODES */
#ifndef OPENSSL_NO_ERR

# define ERR_FUNC(func) ERR_PACK(0,func,0)
# define ERR_REASON(reason) ERR_PACK(0,0,reason)

static ERR_STRING_DATA CTAMC_str_functs[] = {
    {ERR_FUNC(CTAMC_F_CTAMC_CTRL), "CTAMC_CTRL"},
    {ERR_FUNC(CTAMC_F_CTAMC_ECDSA_DO_SIGN), "CTAMC_ECDSA_DO_SIGN"},
    {ERR_FUNC(CTAMC_F_CTAMC_ECDSA_DO_VERIFY), "CTAMC_ECDSA_DO_VERIFY"},
    {ERR_FUNC(CTAMC_F_CTAMC_GET_PSEUDO_RANDOM_BYTES),
     "CTAMC_GET_PSEUDO_RANDOM_BYTES"},
    {ERR_FUNC(CTAMC_F_CTAMC_GET_TRUE_RANDOM_BYTES),
     "CTAMC_GET_TRUE_RANDOM_BYTES"},
    {ERR_FUNC(CTAMC_F_CTAMC_INIT), "CTAMC_INIT"},
    {ERR_FUNC(CTAMC_F_CTAMC_LOAD_PRIVKEY), "CTAMC_LOAD_PRIVKEY"},
    {ERR_FUNC(CTAMC_F_CTAMC_RAND_STATUS), "CTAMC_RAND_STATUS"},
    {ERR_FUNC(CTAMC_F_CTAMC_RSA_PRIV_DEC), "CTAMC_RSA_PRIV_DEC"},
    {ERR_FUNC(CTAMC_F_CTAMC_RSA_PRIV_ENC), "CTAMC_RSA_PRIV_ENC"},
    {ERR_FUNC(CTAMC_F_CTAMC_RSA_PUB_DEC), "CTAMC_RSA_PUB_DEC"},
    {ERR_FUNC(CTAMC_F_CTAMC_RSA_PUB_ENC), "CTAMC_RSA_PUB_ENC"},
    {0, NULL}
};

static ERR_STRING_DATA CTAMC_str_reasons[] = {
    {ERR_REASON(CTAMC_R_ALREADY_LOADED), "already loaded"},
    {ERR_REASON(CTAMC_R_CTRL_COMMAND_NOT_IMPLEMENTED),
     "ctrl command not implemented"},
    {ERR_REASON(CTAMC_R_ENGINE_NOT_INITIALISED), "engine not initialised"},
    {ERR_REASON(CTAMC_R_INTERNAL_ERROR), "internal error"},
    {ERR_REASON(CTAMC_R_INVALID_KEY), "invalid key"},
    {ERR_REASON(CTAMC_R_INVALID_KEY_ID), "invalid key id"},
    {ERR_REASON(CTAMC_R_KEY_NOT_FOUND), "key not found"},
    {ERR_REASON(CTAMC_R_NOT_LOADED), "not loaded"},
    {ERR_REASON(CTAMC_R_PARAMETER_ERROR), "parameter error"},
    {ERR_REASON(CTAMC_R_PASSED_NULL_PARAMETER), "passed null parameter"},
    {0, NULL}
};

#endif

#ifdef CTAMC_LIB_NAME
static ERR_STRING_DATA CTAMC_lib_name[] = {
    {0, CTAMC_LIB_NAME},
    {0, NULL}
};
#endif

static int CTAMC_lib_error_code = 0;
static int CTAMC_error_init = 1;

void ERR_load_CTAMC_strings(void)
{
    if (CTAMC_lib_error_code == 0)
        CTAMC_lib_error_code = ERR_get_next_error_library();

    if (CTAMC_error_init) {
        CTAMC_error_init = 0;
#ifndef OPENSSL_NO_ERR
        ERR_load_strings(CTAMC_lib_error_code, CTAMC_str_functs);
        ERR_load_strings(CTAMC_lib_error_code, CTAMC_str_reasons);
#endif

#ifdef CTAMC_LIB_NAME
        CTAMC_lib_name->error = ERR_PACK(CTAMC_lib_error_code, 0, 0);
        ERR_load_strings(0, CTAMC_lib_name);
#endif
    }
}

void ERR_unload_CTAMC_strings(void)
{
    if (CTAMC_error_init == 0) {
#ifndef OPENSSL_NO_ERR
        ERR_unload_strings(CTAMC_lib_error_code, CTAMC_str_functs);
        ERR_unload_strings(CTAMC_lib_error_code, CTAMC_str_reasons);
#endif

#ifdef CTAMC_LIB_NAME
        ERR_unload_strings(0, CTAMC_lib_name);
#endif
        CTAMC_error_init = 1;
    }
}

void ERR_CTAMC_error(int function, int reason, char *file, int line)
{
    if (CTAMC_lib_error_code == 0)
        CTAMC_lib_error_code = ERR_get_next_error_library();
    ERR_PUT_error(CTAMC_lib_error_code, function, reason, file, line);
}
