/* e_ctame_err.c */
/* ====================================================================
 * Copyright (c) 1999-2011 The OpenSSL Project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit. (http://www.OpenSSL.org/)"
 *
 * 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    openssl-core@OpenSSL.org.
 *
 * 5. Products derived from this software may not be called "OpenSSL"
 *    nor may "OpenSSL" appear in their names without prior written
 *    permission of the OpenSSL Project.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit (http://www.OpenSSL.org/)"
 *
 * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenSSL PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

/*
 * NOTE: this file was auto generated by the mkerr.pl script: any changes
 * made to it will be overwritten when the script next updates this file,
 * only reason strings will be preserved.
 */

#include <stdio.h>
#include <openssl/err.h>
#include "e_ctame_err.h"

/* BEGIN ERROR CODES */
#ifndef OPENSSL_NO_ERR

# define ERR_FUNC(func) ERR_PACK(0,func,0)
# define ERR_REASON(reason) ERR_PACK(0,0,reason)

static ERR_STRING_DATA CTAME_str_functs[] = {
    {ERR_FUNC(CTAME_F_CTAME_ECDSA_DO_SIGN), "CTAME_ECDSA_DO_SIGN"},
    {ERR_FUNC(CTAME_F_CTAME_ECDSA_DO_VERIFY), "CTAME_ECDSA_DO_VERIFY"},
    {ERR_FUNC(CTAME_F_CTAME_EC_GEN_KEYPAIR), "CTAME_EC_GEN_KEYPAIR"},
    {ERR_FUNC(CTAME_F_CTAME_GET_PSEUDO_RANDOM_BYTES),
     "CTAME_GET_PSEUDO_RANDOM_BYTES"},
    {ERR_FUNC(CTAME_F_CTAME_GET_TRUE_RANDOM_BYTES),
     "CTAME_GET_TRUE_RANDOM_BYTES"},
    {ERR_FUNC(CTAME_F_CTAME_LOAD_ECC_PRIVATE_KEY),
     "CTAME_LOAD_ECC_PRIVATE_KEY"},
    {ERR_FUNC(CTAME_F_CTAME_LOAD_RSA_PRIVATE_KEY),
     "CTAME_LOAD_RSA_PRIVATE_KEY"},
    {ERR_FUNC(CTAME_F_CTAME_READ_OBJECT), "CTAME_READ_OBJECT"},
    {ERR_FUNC(CTAME_F_CTAME_RSA_GEN_KEYPAIR), "CTAME_RSA_GEN_KEYPAIR"},
    {ERR_FUNC(CTAME_F_CTAME_RSA_PRIVATE_KEY_DECRYPT),
     "CTAME_RSA_PRIVATE_KEY_DECRYPT"},
    {ERR_FUNC(CTAME_F_CTAME_RSA_PRIVATE_KEY_ENCRYPT),
     "CTAME_RSA_PRIVATE_KEY_ENCRYPT"},
    {ERR_FUNC(CTAME_F_CTAME_RSA_PUBLIC_KEY_DECRYPT),
     "CTAME_RSA_PUBLIC_KEY_DECRYPT"},
    {ERR_FUNC(CTAME_F_CTAME_RSA_PUBLIC_KEY_ENCRYPT),
     "CTAME_RSA_PUBLIC_KEY_ENCRYPT"},
    {0, NULL}
};

static ERR_STRING_DATA CTAME_str_reasons[] = {
    {ERR_REASON(CTAME_R_ECC_PUBLIC_KEY_FAILED), "ecc public key failed"},
    {ERR_REASON(CTAME_R_INVALID_PARM), "invalid parm"},
    {ERR_REASON(CTAME_R_KEY_GEN_FAILED), "key gen failed"},
    {ERR_REASON(CTAME_R_NO_MEMORY), "no memory"},
    {ERR_REASON(CTAME_R_OBJECT_GET_ATTRIBUTE_FAILED),
     "object get attribute failed"},
    {ERR_REASON(CTAME_R_OBJECT_READ_FAILED), "object read failed"},
    {ERR_REASON(CTAME_R_OBJECT_SIZE_ZERO), "object size zero"},
    {ERR_REASON(CTAME_R_OBJECT_WRONG_ATTRIBUTE_TYPE),
     "object wrong attribute type"},
    {ERR_REASON(CTAME_R_OBJ_READ_FAILED), "obj read failed"},
    {ERR_REASON(CTAME_R_RSA_PUBLIC_KEY_FAILED), "rsa public key failed"},
    {0, NULL}
};

#endif

#ifdef CTAME_LIB_NAME
static ERR_STRING_DATA CTAME_lib_name[] = {
    {0, CTAME_LIB_NAME},
    {0, NULL}
};
#endif

static int CTAME_lib_error_code = 0;
static int CTAME_error_init = 1;

void ERR_load_CTAME_strings(void)
{
    if (CTAME_lib_error_code == 0)
        CTAME_lib_error_code = ERR_get_next_error_library();

    if (CTAME_error_init) {
        CTAME_error_init = 0;
#ifndef OPENSSL_NO_ERR
        ERR_load_strings(CTAME_lib_error_code, CTAME_str_functs);
        ERR_load_strings(CTAME_lib_error_code, CTAME_str_reasons);
#endif

#ifdef CTAME_LIB_NAME
        CTAME_lib_name->error = ERR_PACK(CTAME_lib_error_code, 0, 0);
        ERR_load_strings(0, CTAME_lib_name);
#endif
    }
}

void ERR_unload_CTAME_strings(void)
{
    if (CTAME_error_init == 0) {
#ifndef OPENSSL_NO_ERR
        ERR_unload_strings(CTAME_lib_error_code, CTAME_str_functs);
        ERR_unload_strings(CTAME_lib_error_code, CTAME_str_reasons);
#endif

#ifdef CTAME_LIB_NAME
        ERR_unload_strings(0, CTAME_lib_name);
#endif
        CTAME_error_init = 1;
    }
}

void ERR_CTAME_error(int function, int reason, char *file, int line)
{
    if (CTAME_lib_error_code == 0)
        CTAME_lib_error_code = ERR_get_next_error_library();
    ERR_PUT_error(CTAME_lib_error_code, function, reason, file, line);
}
