/* ====================================================================
 * Copyright (c) 2001-2011 The OpenSSL Project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit. (http://www.openssl.org/)"
 *
 * 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    openssl-core@openssl.org.
 *
 * 5. Products derived from this software may not be called "OpenSSL"
 *    nor may "OpenSSL" appear in their names without prior written
 *    permission of the OpenSSL Project.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the OpenSSL Project
 *    for use in the OpenSSL Toolkit (http://www.openssl.org/)"
 *
 * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenSSL PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

#ifndef HEADER_CTAME_ERR_H
# define HEADER_CTAME_ERR_H

#ifdef  __cplusplus
extern "C" {
#endif

/* BEGIN ERROR CODES */
/*
 * The following lines are auto generated by the script mkerr.pl. Any changes
 * made after this point may be overwritten when the script is next run.
 */
void ERR_load_CTAME_strings(void);
void ERR_unload_CTAME_strings(void);
void ERR_CTAME_error(int function, int reason, char *file, int line);
# define CTAMEerr(f,r) ERR_CTAME_error((f),(r),__FILE__,__LINE__)

/* Error codes for the CTAME functions. */

/* Function codes. */
# define CTAME_F_CTAME_ECDSA_DO_SIGN                      100
# define CTAME_F_CTAME_ECDSA_DO_VERIFY                    101
# define CTAME_F_CTAME_EC_GEN_KEYPAIR                     102
# define CTAME_F_CTAME_GET_PSEUDO_RANDOM_BYTES            103
# define CTAME_F_CTAME_GET_TRUE_RANDOM_BYTES              104
# define CTAME_F_CTAME_LOAD_ECC_PRIVATE_KEY               105
# define CTAME_F_CTAME_LOAD_RSA_PRIVATE_KEY               106
# define CTAME_F_CTAME_READ_OBJECT                        107
# define CTAME_F_CTAME_RSA_GEN_KEYPAIR                    108
# define CTAME_F_CTAME_RSA_PRIVATE_KEY_DECRYPT            109
# define CTAME_F_CTAME_RSA_PRIVATE_KEY_ENCRYPT            110
# define CTAME_F_CTAME_RSA_PUBLIC_KEY_DECRYPT             111
# define CTAME_F_CTAME_RSA_PUBLIC_KEY_ENCRYPT             112

/* Reason codes. */
# define CTAME_R_ECC_PUBLIC_KEY_FAILED                    100
# define CTAME_R_INVALID_PARM                             101
# define CTAME_R_KEY_GEN_FAILED                           102
# define CTAME_R_NO_MEMORY                                103
# define CTAME_R_OBJECT_GET_ATTRIBUTE_FAILED              104
# define CTAME_R_OBJECT_READ_FAILED                       105
# define CTAME_R_OBJECT_SIZE_ZERO                         106
# define CTAME_R_OBJECT_WRONG_ATTRIBUTE_TYPE              107
# define CTAME_R_OBJ_READ_FAILED                          108
# define CTAME_R_RSA_PUBLIC_KEY_FAILED                    109

#ifdef  __cplusplus
}
#endif
#endif
