/** @file */
/* -----------------------------------------------------------------
 * ssmc_rnd.c
 *
 * SSMc random number gen
 *
 * Trusted Services interest-ctam@cisco.com
 *
 * Copyright  (c) 2014 by Cisco Systems, Inc.
 * All rights reserved.
 *------------------------------------------------------------------
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>

#include "tamc_ssm_api.h"
#include "ssmc.h"

/** @brief tamc_drand_read - Request DRBG generated random data.
 * @param *vsession - client/server session used to request services.
 * @param *drand_len - amount of random data requested
 * @param **drand - returned buffer with random data, if successful
 * @return TAM_SUCCESS or error code.
 */
static tam_status_e tamc_drand_read(void *session,
                                    uint32_t drand_len, uint8_t ** data)
{

    tam_status_e rc = TAM_ERROR_UNSUPPORTED_COMMAND;
    /*
     * Not supported when using SSM.
     * CiscoSSL rnd default method is used
     */
    return rc;
}

/** @brief tamc_trand_read - Request true random data (i.e. entropy).
 * @param *vsession - client/server session used to request services.
 * @param *trand_len - amount of random data requested
 * @param **data - returned buffer with random data, if successful
 * @return TAM_SUCCESS or error code.
 */
static tam_status_e
tamc_trand_read(void *vsession, uint32_t trand_len, uint8_t ** data)
{
    tam_status_e rc = TAM_ERROR_UNSUPPORTED_COMMAND;
    /*
     * Not supported when using SSM.
     * CiscoSSL rnd default method is used
     */
    return rc;
}
