/* ctamc_tam_config.h */
/* Copyright (C) 2014 Cisco Systems
 * All rights reserved.
 */

#ifndef __CTAMC_TAM_CONFIG_H__
# define __CTAMC_TAM_CONFIG_H__
# include "tam_types.h"

# define MAX_APPS             16
# define MAX_DEV              16
# define APPID_LEN_MAX        64
# define DEVICE_NAME_MAX_LEN  64
# define PW_LEN_MAX          256

# define DEVICE_TYPE_ACT2    1
# define DEVICE_TYPE_SWTAM   2
# define SYS_STATE_NO_CONFIG 0
# define SYS_STATE_READY     3

/*
 * Apps
 *
 */
typedef struct app_data_ {
    char name[APPID_LEN_MAX];   /* App Name */
    char password[PW_LEN_MAX];  /* passwrd */
    void *session;              /* session in this case... 1 session per app */
    void *ctx;
} app_data_t;

/*
 * Devices
 *
 */

typedef struct dev_data_ {
    char name[DEVICE_NAME_MAX_LEN]; /* device Name */
    int num_apps;
    int type;                   /* sw or hw TAM */
    uint32_t context;           /* device context */
    app_data_t apps[MAX_APPS];
} dev_data_t;

/*
 * System
 */
typedef struct tam_system_ {
    int num_sw_dev;             /* number of sw devices used */
    int num_hw_dev;             /* number of hw devices used */
    dev_data_t sw_dev[MAX_DEV];
    dev_data_t hw_dev[MAX_DEV];
} tam_system_t;

#endif                          // __CTAMC_TAM_CONFIG_H__
